part of hakkit.hakk.builder.basic;

abstract class _OperatorClass{
  _ExpressionNode operator +(next){
    next = _wrapLiteral(next);
    final node = new _ExpressionNode(this, next, 'add');
    _expressionQueue.add(node);
    return node;
  }
  
  _ExpressionNode operator -(next){
    next = _wrapLiteral(next);
    final node = new _ExpressionNode(this, next, 'sub');
    _expressionQueue.add(node);
    return node;
  }
  
  _ExpressionNode operator /(next){
    next = _wrapLiteral(next);
    final node = new _ExpressionNode(this, next, 'div');
    _expressionQueue.add(node);
    return node;
  }
  
  _ExpressionNode operator *(next){
    next = _wrapLiteral(next);
    final node = new _ExpressionNode(this, next, 'mul');
    _expressionQueue.add(node);
    return node;
  }
  
  _ExpressionNode operator <(next){
    next = _wrapLiteral(next);
    final node = new _ExpressionNode(this, next, 'jl');
    _expressionQueue.add(node);
    return node;
  }
  
  _ExpressionNode operator >(next){
    next = _wrapLiteral(next);
    final node = new _ExpressionNode(this, next, 'jg');
    _expressionQueue.add(node);
    return node;
  }
  
  _ExpressionNode operator <=(next){
    next = _wrapLiteral(next);
    final node = new _ExpressionNode(this, next, 'jle');
    _expressionQueue.add(node);
    return node;
  }
  
  _ExpressionNode operator >=(next){
    next = _wrapLiteral(next);
    final node = new _ExpressionNode(this, next, 'jge');
    _expressionQueue.add(node);
    return node;
  }
  
  operator ==(next){
    next = _wrapLiteral(next);
    final node = new _ExpressionNode(this, next, 'je');
    _expressionQueue.add(node);
    return node;
  }
  
  _ExpressionNode operator &(next){
    next = _wrapLiteral(next);
    final node = new _ExpressionNode(this, next, '&');
    _expressionQueue.add(node);
    return node;
  }
  
  _ExpressionNode operator |(next){
    next = _wrapLiteral(next);
    final node = new _ExpressionNode(this, next, '|');
    _expressionQueue.add(node);
    return node;
  }
}